package dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import pojo.Calcado;
import pojo.TipoCalcado;

public class Dao {

	Connection conexao = GenericDao.getConnection();
	
	public List<TipoCalcado> consultaTipo(){
		List<TipoCalcado> listTipoCalcado = new ArrayList<TipoCalcado>();
		ResultSet rs = null;
		try{
			PreparedStatement ps = conexao.prepareStatement("select codigo, tipo from tipo");
			ps.execute();
			rs = ps.getResultSet();
			while (rs.next()){
				TipoCalcado tipoCalcado = new TipoCalcado();
				tipoCalcado.setCodigoTipo(rs.getInt("codigo"));
				tipoCalcado.setTipoTipo(rs.getString("tipo"));
				listTipoCalcado.add(tipoCalcado);
			}
			ps.close();
		}catch (Exception e){
			e.printStackTrace();
		}
		return listTipoCalcado;
	}
	
	public boolean insereCalcado(Calcado calcado){
		boolean inserido = false;
		try{
			PreparedStatement ps = conexao.prepareStatement("insert into calcado values (?,?,?,?)");
			ps.setString(1, calcado.nome);
			ps.setString(2, calcado.cor);
			ps.setString(3, calcado.sexo);
			ps.setInt(4, calcado.codigoTipo);
			ps.execute();
			ps.close();
			inserido = true;
		}catch (Exception e) {
			e.printStackTrace();
		}
		return inserido;
	}
	
	public Calcado consultaCalcado (int codigo){
		Calcado calcado = new Calcado();
		ResultSet rs = null;
		ResultSet rs1 = null;
		
		try{
			PreparedStatement ps = conexao.prepareStatement("select * from calcado where codigo = ?");
			ps.setInt(1, codigo);
			ps.execute();
			rs = ps.getResultSet();
			if (rs.next()){
				calcado.setNome(rs.getString(2));
				calcado.setCor(rs.getString(3));
				calcado.setSexo(rs.getString(4));
				calcado.setCodigoTipo(rs.getInt(5));
			}
			PreparedStatement ps1 = conexao.prepareStatement("select tipo from tipo where codigo = ?");
			ps1.setInt(1,calcado.getCodigoTipo());
			ps1.execute();
			rs1 = ps1.getResultSet();
			if(rs.next()){
				calcado.setTipoTipo(rs1.getString(1));
			}
			ps.close();
			ps1.close();
		} catch (Exception e){
			e.printStackTrace();
		}
		return calcado;
	}
	
	public boolean atualizaCalcado(Calcado calcado){
		boolean editado = false;
		try{
			PreparedStatement ps = conexao.prepareStatement("update calcado set nome = ?, cor = ?, sexo = ?, tipo = ? where codigo = ?");
			ps.setString(1, calcado.getNome());
			ps.setString(2, calcado.getCor());
			ps.setString(3, calcado.getSexo());
			ps.setInt(4, calcado.getCodigoTipo());
			ps.setInt(5, calcado.getCodigo());
			ps.execute();
			ps.close();
			editado = true;
		} catch(Exception e){
			e.printStackTrace();
		}
		return editado;
	}
	
	public boolean deletaCalcado(int codigo){
		boolean deletado = false;
		try{
			PreparedStatement ps = conexao.prepareStatement("delete calcado where codigo = ?");
			ps.setInt(1,codigo);
			ps.execute();
			ps.close();
			deletado = true;
		}catch(Exception e){
			e.printStackTrace();
		}
		return deletado;
	}
	
}
