package view;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;

import dao.Dao;

import pojo.Calcado;
import pojo.TipoCalcado;

public class CadastroCalcado extends JFrame {

	private JPanel contentPane;
	private JTextField tfNome = new JTextField();
	private JTextField tfCor = new JTextField();
	private JComboBox cbSexo = new JComboBox();
	private JComboBox cbTipo = new JComboBox();
	
	private List<TipoCalcado> listaTipoCalcado;
	
	Dao dao = new Dao();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					CadastroCalcado frame = new CadastroCalcado();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	
	private void cadastrarCalcado(){
		final Calcado calcado = new Calcado();
		calcado.nome = tfNome.getText();
		calcado.cor = tfCor.getText();
		calcado.sexo = String.valueOf(cbSexo.getSelectedItem());
		calcado.codigoTipo = cbTipo.getSelectedIndex()+1;
		if(!tfNome.getText().isEmpty()){
			boolean inserido = dao.insereCalcado(calcado);
			if(inserido){
				JOptionPane.showMessageDialog(null, "Inserido","Parabns",
						JOptionPane.INFORMATION_MESSAGE);
			} else {
				JOptionPane.showMessageDialog(null, "No Inserido","Erro",
						JOptionPane.ERROR_MESSAGE);
			}
		} else {
			JOptionPane.showMessageDialog(null, "Preencha Todos os Campos !!!", 
					"Erro", JOptionPane.ERROR_MESSAGE);
		}
		tfNome.setText("");
		tfCor.setText("");
		cbSexo.setSelectedIndex(0);
		cbTipo.setSelectedIndex(0);
	}
	
	/**
	 * Create the frame.
	 */
	public CadastroCalcado() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 500, 400);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JLabel lblNome = new JLabel("Nome");
		lblNome.setBounds(10, 78, 46, 14);
		contentPane.add(lblNome);
		
		tfNome.setBounds(66, 75, 203, 20);
		contentPane.add(tfNome);
		tfNome.setColumns(10);
		
		JLabel lblCor = new JLabel("Cor");
		lblCor.setBounds(10, 132, 46, 14);
		contentPane.add(lblCor);
		
		tfCor.setBounds(66, 129, 86, 20);
		contentPane.add(tfCor);
		tfCor.setColumns(10);
		
		JLabel lblSexo = new JLabel("Sexo");
		lblSexo.setBounds(10, 193, 46, 14);
		contentPane.add(lblSexo);
		
		
		cbSexo.setModel(new DefaultComboBoxModel(new String[] {"F", "M"}));
		cbSexo.setBounds(66, 190, 51, 20);
		contentPane.add(cbSexo);
		
		JLabel lblTipo = new JLabel("Tipo");
		lblTipo.setBounds(10, 254, 46, 14);
		contentPane.add(lblTipo);
		

		cbTipo.setBounds(66, 251, 130, 20);
		contentPane.add(cbTipo);
		listaTipoCalcado = dao.consultaTipo();
		for(TipoCalcado tipoCalcado : listaTipoCalcado){
			cbTipo.addItem(tipoCalcado.getTipoTipo());
		}
		
		JButton btnInsere = new JButton("Insere");
		btnInsere.setBounds(10, 318, 89, 23);
		contentPane.add(btnInsere);
		
		btnInsere.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cadastrarCalcado();
			}
		});
	}
}
