package view;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;

import dao.Dao;

import pojo.Calcado;
import pojo.TipoCalcado;

public class EditaCalcado extends JFrame {

	private JPanel contentPane;
	private JTextField tfNome = new JTextField();
	private JTextField tfCor = new JTextField();
	private JComboBox cbSexo = new JComboBox();
	private JComboBox cbTipo = new JComboBox();
	
	private List<TipoCalcado> listaTipoCalcado;
	
	Dao dao = new Dao();
	private JTextField tfCodigo;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					EditaCalcado frame = new EditaCalcado();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	public void consultaCalcado(int codigo){
		Calcado calcado = new Calcado();
		calcado = dao.consultaCalcado(codigo);
		tfNome.setText(calcado.getNome());
		tfCor.setText(calcado.getCor());
		if (calcado.getSexo().equals("F")){
			cbSexo.setSelectedIndex(0);
		} else {
			cbSexo.setSelectedIndex(1);
		}
		cbTipo.setSelectedIndex(calcado.getCodigoTipo()-1);
	}
	
	public void habilitaEdicao(){
		tfCodigo.setEnabled(false);
		tfNome.setEnabled(true);
		tfCor.setEnabled(true);
		cbSexo.setEnabled(true);
		cbTipo.setEnabled(true);
	}
	
	public void desabilitaEdicao(){
		tfCodigo.setEnabled(true);
		tfNome.setEnabled(false);
		tfCor.setEnabled(false);
		cbSexo.setEnabled(false);
		cbTipo.setEnabled(false);
		tfCodigo.setText("");
		tfNome.setText("");
		tfCor.setText("");
		cbSexo.setSelectedIndex(0);
		cbTipo.setSelectedIndex(0);
	}
	
	public void editaCalcado(){
		Calcado calcado = new Calcado();
		calcado.codigo = Integer.parseInt(tfCodigo.getText());
		calcado.nome = tfNome.getText();
		calcado.cor = tfCor.getText();
		calcado.sexo = String.valueOf(cbSexo.getSelectedItem());
		calcado.codigoTipo = cbTipo.getSelectedIndex()+1;
		boolean editado = dao.atualizaCalcado(calcado);
		if (editado) {
			JOptionPane.showMessageDialog(null, "Editado", "Parabns !",
					JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showMessageDialog(null, "Erro", "Erro !",
					JOptionPane.ERROR_MESSAGE);
		}
		desabilitaEdicao();
	}
	
	public void deletaCalcado(){
		boolean deletado = dao.deletaCalcado(Integer.parseInt(tfCodigo.getText()));
		if (deletado){
			JOptionPane.showMessageDialog(null, "Deletado", "Parabns !",
					JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showMessageDialog(null, "Erro", "Erro !",
					JOptionPane.ERROR_MESSAGE);
		}
		desabilitaEdicao();
	}
	
	/**
	 * Create the frame.
	 */
	public EditaCalcado() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 500, 400);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JLabel lblNome = new JLabel("Nome");
		lblNome.setBounds(10, 78, 46, 14);
		contentPane.add(lblNome);
		tfNome.setEnabled(false);
		
		tfNome.setBounds(66, 75, 203, 20);
		contentPane.add(tfNome);
		tfNome.setColumns(10);
		
		JLabel lblCor = new JLabel("Cor");
		lblCor.setBounds(10, 132, 46, 14);
		contentPane.add(lblCor);
		tfCor.setEnabled(false);
		
		tfCor.setBounds(66, 129, 86, 20);
		contentPane.add(tfCor);
		tfCor.setColumns(10);
		
		JLabel lblSexo = new JLabel("Sexo");
		lblSexo.setBounds(10, 193, 46, 14);
		contentPane.add(lblSexo);
		cbSexo.setEnabled(false);
		
		
		cbSexo.setModel(new DefaultComboBoxModel(new String[] {"F", "M"}));
		cbSexo.setBounds(66, 190, 51, 20);
		contentPane.add(cbSexo);
		
		JLabel lblTipo = new JLabel("Tipo");
		lblTipo.setBounds(10, 254, 46, 14);
		contentPane.add(lblTipo);
		cbTipo.setEnabled(false);
		

		cbTipo.setBounds(66, 251, 130, 20);
		contentPane.add(cbTipo);
		listaTipoCalcado = dao.consultaTipo();
		for(TipoCalcado tipoCalcado : listaTipoCalcado){
			cbTipo.addItem(tipoCalcado.getTipoTipo());
		}
		
		JLabel lblCdigo = new JLabel("C\u00F3digo");
		lblCdigo.setBounds(10, 21, 46, 14);
		contentPane.add(lblCdigo);
		
		tfCodigo = new JTextField();
		tfCodigo.setBounds(66, 21, 86, 20);
		contentPane.add(tfCodigo);
		tfCodigo.setColumns(10);
		
		JButton btnConsulta = new JButton("Consulta");
		btnConsulta.setBounds(10, 299, 89, 23);
		contentPane.add(btnConsulta);
		
		JButton btnEdicao = new JButton("Edi\u00E7\u00E3o");
		btnEdicao.setBounds(142, 299, 89, 23);
		contentPane.add(btnEdicao);
		
		JButton btnEdita = new JButton("Edita");
		btnEdita.setBounds(10, 333, 89, 23);
		contentPane.add(btnEdita);
		
		JButton btnApaga = new JButton("Apaga");
		btnApaga.setBounds(142, 333, 89, 23);
		contentPane.add(btnApaga);
		
		btnConsulta.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				consultaCalcado(Integer.parseInt(tfCodigo.getText()));
			}
		});
		
		tfCodigo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				consultaCalcado(Integer.parseInt(tfCodigo.getText()));
			}
		});
		
		btnEdita.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				habilitaEdicao();
			}
		});
		
		btnEdicao.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				editaCalcado();
			}
		});
		
		btnApaga.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				deletaCalcado();
			}
		});
	}
}
